VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmBatchPrintStatements_Levy 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Printing Levy Statements of Account"
   ClientHeight    =   1560
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7065
   Icon            =   "Batch Print Levy Statements.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1560
   ScaleWidth      =   7065
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2805
      TabIndex        =   1
      Top             =   960
      Width           =   1455
   End
   Begin MSComctlLib.ProgressBar ProgressBar 
      Height          =   315
      Left            =   225
      TabIndex        =   0
      Top             =   360
      Width           =   6615
      _ExtentX        =   11668
      _ExtentY        =   556
      _Version        =   393216
      Appearance      =   1
   End
End
Attribute VB_Name = "frmBatchPrintStatements_Levy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Loading As Boolean
Private rstStudentsAffected As Recordset
Private rstCurrentStatement As Recordset

Private Sub cmdCancel_Click()
    On Local Error Resume Next
    'cancels job that has not yet been commited
    Printer.KillDoc
    Unload Me
End Sub

Private Sub Form_Activate()
    If CurrentUser.Allowed_LevyAc_BatchStmt Then
        DoBatchPrint
    Else
        GiveSecViolationMsg ("batch print Levy Fees statements")
        Unload Me
    End If
        
End Sub

Private Sub DoBatchPrint()
    Dim strMsg As String
    
    Dim rstStudentsAffected As Recordset
    Dim rstCurrentStatement As Recordset
    Dim lngCounter As Long
        
    Dim strStudentID As String
    Dim strStudentName As String
    Dim strStudentClass As String
    Dim dtmStartDate As Date
    Dim dtmEndDate As Date
    
    Dim curOpeningBalance As Currency
    Dim curClosingBalance As Currency
    
    If Loading Then
        Loading = False
        ProgressBar.Value = 0
        Me.Refresh
        
        'Set the starting and ending dates
        dtmStartDate = frmBatchPrintStatements_StartUp.dtpickStartDate.Value
        dtmEndDate = frmBatchPrintStatements_StartUp.dtpickEndDate.Value
        
        'Get list of affected students
        Set rstStudentsAffected = GetListOfAffectedStudents
        
        'For each student, generate a statement and print it
        If rstStudentsAffected.RecordCount = 0 Then
            strMsg = "There are no students in the selected classes matching the specified criteria."
            MsgBox strMsg, vbExclamation, "Batch Print Levy Statements"
            Unload Me
        Else
            'Populate recordset and move to the first record
            rstStudentsAffected.MoveLast
            rstStudentsAffected.MoveFirst
            For lngCounter = 1 To rstStudentsAffected.RecordCount
                strStudentID = rstStudentsAffected("Student ID")
                strStudentName = rstStudentsAffected("Name")
                strStudentClass = rstStudentsAffected("Class")
                
                'Obtain opening and closing balance
                curOpeningBalance = GetLevyOpeningBalance(strStudentID, dtmStartDate)
                curClosingBalance = GetLevyClosingBalance(strStudentID, dtmEndDate)
                
                'Generate statement body excluding opening and closing balances
                Set rstCurrentStatement = GetStatementBody(strStudentID, dtmStartDate, dtmEndDate)
                
                'Print statement
                Call PrintStatement(strStudentID, strStudentName, strStudentClass, _
                                    dtmStartDate, dtmEndDate, curOpeningBalance, _
                                    curClosingBalance, rstCurrentStatement)
                
                'Report progress
                ProgressBar.Value = Int(lngCounter / rstStudentsAffected.RecordCount * 100)
                Me.Refresh
                
                'Process external events e.g. Cancel button
                DoEvents
                rstStudentsAffected.MoveNext
            Next
            'commit print job
            Printer.EndDoc
            Unload Me
        End If
    End If
End Sub

Private Function GetStatementBody(ByVal strStudentID As String, ByVal dtmStartDate As Date, ByVal dtmEndDate As Date) As Recordset
    'Returns a recordset with the all the levy transaction between the supplied dates
    Dim strSQL As String
    
    strSQL = GetLevyStatementBodySQL
    qryQueryObject.SQL = strSQL
    qryQueryObject.Parameters("The Student") = strStudentID
    qryQueryObject.Parameters("Start Date") = dtmStartDate
    qryQueryObject.Parameters("End Date") = dtmEndDate
    Set GetStatementBody = qryQueryObject.OpenRecordset
                
End Function

Private Sub PrintStatement(strStudentID As String, strStudentName As String, _
                            strStudentClass As String, dtmStartDate As Date, _
                            dtmEndDate As Date, curOpeningBalance As Currency, _
                            curClosingBalance As Currency, rstStatement As Recordset)
    
    
    Dim lngRowCounter As Long
    Dim strBalanceDescription As String
    Dim strStatementPeriod As String
    
    'Text for statement period line
    strStatementPeriod = Format(dtmStartDate, "d mmmm yyyy") _
                       & " - " & Format(dtmEndDate, "d mmmm yyyy")
    
    'Balance description text
    If curClosingBalance <= 0 Then
        strBalanceDescription = "Balance Owing "
    Else
        strBalanceDescription = "Levies Prepaid "
    End If
    
        
    'Print Header
    Printer.CurrentY = 3
    PrintHeader ("Mount Pleasant High School")
    PrintHeader ("Levy Statement Of Account")
    
        
    'Printing student details
    Printer.CurrentY = Printer.CurrentY + 1
    PrintStudentDetails "Student ID ", strStudentID
    PrintStudentDetails "Name", strStudentName
    PrintStudentDetails "Class", strStudentClass
    PrintStudentDetails "Statement Period", strStatementPeriod
    PrintStudentDetails strBalanceDescription, CurrencyFormat(curClosingBalance)
    
    PrintBlankLines (2)
    
    'Printing header of column names
    PrintHeaderRow
    Printer.CurrentY = Printer.CurrentY + 1
    
    Call PrintBalance(dtmStartDate, "Opening Balance", curOpeningBalance)
    If rstStatement.RecordCount <> 0 Then
        rstStatement.MoveFirst
        For lngRowCounter = 1 To rstStatement.RecordCount
            'If current line 3 rows from end of page then request new page and print a header
            If Printer.CurrentY >= Printer.ScaleHeight - 3 Then
                Printer.NewPage
                Printer.CurrentY = 2
                PrintHeaderRow
                Printer.CurrentY = Printer.CurrentY + 1
            End If
            
            'Transaction date
            Printer.CurrentX = getCurrentX(0)
            Printer.Print Format(rstStatement("Transaction Date"), "dd mmm yyyy");
            
            'Description
            Printer.CurrentX = getCurrentX(1)
            Printer.Print rstStatement("Description");
            
            'Amount
            Printer.CurrentX = getCurrentX(2)
            If rstStatement("Amount") < 0 Then
                Printer.Print CurrencyFormat(rstStatement("Amount"))
            Else
                Printer.Print CurrencyFormat(rstStatement("Amount"))
            End If
            rstStatement.MoveNext
        Next
    End If
        
    Call PrintBalance(dtmEndDate, "Closing Balance", curClosingBalance)
    Printer.NewPage
    
            
End Sub

Private Sub PrintBalance(EntryDate As Date, Description As String, curAmount As Currency)
    
    Printer.CurrentX = getCurrentX(0)
    Printer.Print Format(EntryDate, "dd mmm yyyy");
    
    Printer.CurrentX = getCurrentX(1)
    Printer.Print Description;
    
    Printer.CurrentX = getCurrentX(2)
    If curAmount < 0 Then
        Printer.Print CurrencyFormat(curAmount)
    Else
        Printer.Print CurrencyFormat(curAmount)
    End If
    
End Sub

Private Function GetListOfAffectedStudents() As Recordset
    
    Dim objHostList As ListBox
    Dim strSQL As String
    Dim lngCounter As Long
    Dim strClassCriteriaSet As String
    
    strSQL = "SELECT [Student ID], " _
          & "       ([Surname]&' '&[First Names]) as [Name], " _
          & "       [Class], " _
          & "       (IIF(isNull([Unrevised Debits]),0,([Unrevised Debits]))*-1) AS [Total Debits], " _
          & "       IIF (isNull([Unrevised Credits]),0,[Unrevised Credits]) AS  [Total Credits], " _
          & "       ([Total Credits] + [Total Debits]) AS Balance " _
          & "FROM  " _
          & "( " _
          & "   SELECT DISTINCTROW " _
          & "        [Students].[Student ID] AS [Student ID], " _
          & "        [Students].[Surname] AS [Surname], " _
          & "        [Students].[First Names] AS [First Names], " _
          & "        [Students].[Class] AS [Class], " _
          & "        ( SELECT     Sum([Levy Account Credits].[Amount]) " _
          & "          FROM       [Levy Account Credits] " _
          & "          WHERE [Levy Account Credits].[Student ID] = [Students].[Student ID] " _
          & "        )   AS [Unrevised Credits], " _
          & "        ( SELECT     Sum([Levy Account Debits].[Amount]) " _
          & "          FROM [Levy Account Debits] " _
          & "          WHERE [Levy Account Debits].[Student ID] = [Students].[Student ID] " _
          & "        ) AS [Unrevised Debits] " _
          & "   FROM   [Students], [Levy Account Debits], [Levy Account Credits] " _
          & ") " _
          & "ORDER BY [Class],[Student ID]"
    
    'Reselect as to factor in balance types
    If frmBatchPrintStatements_StartUp.optAccrued.Value Then
        strSQL = "Select * From (" & strSQL & ") WHERE Balance < 0"
    ElseIf frmBatchPrintStatements_StartUp.optPrepaid.Value Then
        strSQL = "Select * From (" & strSQL & ") WHERE Balance > 0"
    ElseIf frmBatchPrintStatements_StartUp.optSettled.Value Then
        strSQL = "Select * From (" & strSQL & ") WHERE Balance = 0"
    End If
    
    'Reselect to factor in classes
    Set objHostList = frmBatchPrintStatements_StartUp.lstSelectedClasses
    strClassCriteriaSet = "'" & Trim(objHostList.List(0)) & "'"
    If objHostList.ListCount > 1 Then
        For lngCounter = 1 To objHostList.ListCount - 1
            strClassCriteriaSet = strClassCriteriaSet _
                                & ",'" & Trim(objHostList.List(lngCounter)) & "'"
        Next
    End If
    strClassCriteriaSet = "(" & strClassCriteriaSet & ")"
    
    strSQL = "SELECT * " _
          & "FROM   (" & strSQL & ")" _
          & "WHERE  [Class] IN " & strClassCriteriaSet
    
    qryQueryObject.SQL = strSQL
    Set GetListOfAffectedStudents = qryQueryObject.OpenRecordset
    
End Function

Private Sub PrintHeaderRow()
    Dim lngColCounter As Long
    
    
    Printer.CurrentX = getCurrentX(0)
    Printer.Print "Date";
    
    Printer.CurrentX = getCurrentX(1)
    Printer.Print "Details";
    
    Printer.CurrentX = getCurrentX(2)
    Printer.Print "   Amount"
    
    Printer.Line (0, Printer.CurrentY)-(Printer.ScaleWidth, Printer.CurrentY)
    
    
End Sub

Private Function getCurrentX(Column As Long) As Long
    Dim lngReturnValue As Long
    
    Select Case Column
        Case 0
            lngReturnValue = 3
        Case 1
            lngReturnValue = 22
        Case 2
            lngReturnValue = 65
    End Select
    
    getCurrentX = lngReturnValue
    
End Function

Private Sub Form_Load()
    Loading = True
End Sub
