VERSION 5.00
Begin VB.Form frmLevy_RegisteredFees 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Registered Fees"
   ClientHeight    =   4275
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6825
   HelpContextID   =   810
   Icon            =   "Registered Fees.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4275
   ScaleWidth      =   6825
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdDelete 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   555
      Left            =   6000
      Picture         =   "Registered Fees.frx":0442
      Style           =   1  'Graphical
      TabIndex        =   3
      ToolTipText     =   "Delete Currently selected fee"
      Top             =   1080
      Width           =   675
   End
   Begin VB.CommandButton cmdNew 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   555
      Left            =   6000
      Picture         =   "Registered Fees.frx":074C
      Style           =   1  'Graphical
      TabIndex        =   2
      ToolTipText     =   "Add new fee"
      Top             =   360
      Width           =   675
   End
   Begin VB.CommandButton cmdHelp 
      Height          =   555
      Left            =   6000
      Picture         =   "Registered Fees.frx":0A56
      Style           =   1  'Graphical
      TabIndex        =   1
      ToolTipText     =   "Help"
      Top             =   1800
      Width           =   675
   End
   Begin VB.ListBox lstRegisteredFees 
      Height          =   3765
      Left            =   180
      TabIndex        =   0
      Top             =   360
      Width           =   5595
   End
End
Attribute VB_Name = "frmLevy_RegisteredFees"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Mantains the registered fees table

Option Explicit
Private Loading As Boolean

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdDelete_Click()
    If CurrentUser.Allowed_Fees_Registered_Delete Then
        DoDelete
    Else
        GiveSecViolationMsg "deregister levy fees"
    End If
    
End Sub

Private Sub DoDelete()
    'Deletes a fee from the registered fees table provided it is not referenced in
    'the levy debits table and in any of the templates
    
    Dim strstrFeeName As String
    Dim lnglngFeeCode As Long
    Dim lngLevyDebitsReferences As Long
    Dim lngTemplateReferences As Long
    Dim strMsg As String
    
    
    If lstRegisteredFees.ListCount = 0 Then
        strMsg = "There are no fees currently registered"
        MsgBox strMsg, vbExclamation, "Delete Fee"
    ElseIf lstRegisteredFees.ListIndex = -1 Then
        strMsg = "Please select a fee first"
        MsgBox strMsg, vbExclamation, "Delete Fee"
    Else
        'get fee name
        strstrFeeName = lstRegisteredFees.List(lstRegisteredFees.ListIndex)
        'locate fee in table
        rstRegisteredFees.Index = "Fee Name Index"
        rstRegisteredFees.Seek "=", strstrFeeName
        
        If rstRegisteredFees.NoMatch Then
            'just defensive....
            strMsg = "The fee could was not deleted because the original record could not be found"
            MsgBox strMsg, vbCritical, "System Error"
        Else
            lnglngFeeCode = rstRegisteredFees("Fee Code")
            'Ensure that fee is not currently in use
            'Levy debits table
            lngLevyDebitsReferences = GetLevyDebitsReferences(lnglngFeeCode)
            
            'templates table
            lngTemplateReferences = GetTemplateReferences(lnglngFeeCode)
            
            If lngLevyDebitsReferences <> 0 Or lngTemplateReferences <> 0 Then
                strMsg = "The fee cannot be deleted because it is currently in use. " _
                       & strNewLine & strNewLine _
                       & "The number of refences, as to sector, are as follows:" & strNewLine _
                       & "Levy Debits" & Tabs(1) & Str(lngLevyDebitsReferences) & strNewLine _
                       & "Templates" & Tabs(1) & Str(lngTemplateReferences) & strNewLine
                MsgBox strMsg, vbExclamation, "Delete Fee"
            Else
                'delete fee
                rstRegisteredFees.Delete
                'update the displayed list of fees
                LoadFeesIntoListBox
                'give confirmation
                MsgBox "Fee successfully deleted", vbInformation, "Delete Fee"
            End If
        End If
    End If
    
End Sub

Private Function GetLevyDebitsReferences(lnglngFeeCode As Long) As Long
    'Returns the number of records in the debits table that reference a given
    'fee code
    Dim strSQL As String
    Dim rstTotalReferences As Recordset
    
    strSQL = "SELECT count(*) as [Total References] " _
             & "FROM [Levy Account Debits] " _
             & "WHERE [Fee Code] = [Supplied Code]"
    
    qryQueryObject.SQL = strSQL
    qryQueryObject.Parameters("Supplied Code") = lnglngFeeCode
    Set rstTotalReferences = qryQueryObject.OpenRecordset
    
    GetLevyDebitsReferences = rstTotalReferences("Total References")
    
End Function


Private Function GetTemplateReferences(lnglngFeeCode As Long) As Long
    'Returns the number of templates that reference a given fee code
    Dim strSQL As String
    Dim rstTemplateRefs As Recordset
    
    strSQL = "SELECT count(*) as [Total References] " _
             & "FROM [Fees Templates] " _
             & "WHERE [Template Data] LIKE '*" & Trim(Str(lnglngFeeCode)) & ",*'"
    
    qryQueryObject.SQL = strSQL
    Set rstTemplateRefs = qryQueryObject.OpenRecordset
    
    GetTemplateReferences = rstTemplateRefs("Total References")
    
End Function



Private Sub cmdHelp_Click()
    ShowHelpTopic 810
End Sub

Private Sub cmdNew_Click()
    
    If CurrentUser.Allowed_Fees_Registered_AddNew Then
        DoCreateFee
    Else
        GiveSecViolationMsg "register new fees"
    End If
        
End Sub

Private Sub DoCreateFee()

    'Creates a new registered fee
    Dim strProposedName As String
    Dim lnglngFeeCode As Long
    Dim strMsg As String
    
    'Get the propsed name for the registered fee
    strMsg = "Enter the official title of the fee"
    strProposedName = InputBox(strMsg, "New Fee", , , , getHelpFilePath, 820)
    strProposedName = Trim(strProposedName)
    
    'check if name is alreday in use
    rstRegisteredFees.Index = "Fee Name Index"
    rstRegisteredFees.Seek "=", strProposedName
    
    
    If strProposedName = "" Then
        strMsg = "Fee not registered because a name was not supplied"
        MsgBox strMsg, vbExclamation, "New Fee"
    ElseIf Not (rstRegisteredFees.NoMatch) Then
        strMsg = "This fee has already been registered"
        MsgBox strMsg, vbExclamation, "New Fee"
    ElseIf Len(strProposedName) > 30 Then
        strMsg = "The fee name should not exceed 30 characters"
        MsgBox strMsg, vbExclamation, "New Fee"
    Else
        'get a new fee code
        lnglngFeeCode = findFreeCode
        'add fee to table
        rstRegisteredFees.AddNew
            rstRegisteredFees("Fee Code") = lnglngFeeCode
            rstRegisteredFees("Fee Name") = strProposedName
        rstRegisteredFees.Update
        'update list of displayed fees
        LoadFeesIntoListBox
    End If
    
End Sub

Private Function findFreeCode() As Long
    Dim lngCounter As Long
    Dim blnCodeFound As Boolean
    
    rstRegisteredFees.Index = "Fee Code Index"
    lngCounter = 1
    
    Do
        rstRegisteredFees.Seek "=", lngCounter
        If rstRegisteredFees.NoMatch Then
            blnCodeFound = True
        Else
            lngCounter = lngCounter + 1
        End If
    Loop Until blnCodeFound
    
    findFreeCode = lngCounter
    
End Function

Private Sub Form_Activate()
    If Loading Then
        Loading = False
        LoadFeesIntoListBox
    End If
End Sub

Private Sub LoadFeesIntoListBox()
    Dim lngCounter As Long
    
    'clear the list first
    lstRegisteredFees.Clear
    
    'if the list of registered fees is not empty then ...
    If rstRegisteredFees.RecordCount <> 0 Then
        'sort the fees as to the fee name
        rstRegisteredFees.Index = "Fee Name Index"
        'go to first one
        rstRegisteredFees.MoveFirst
        'add each fee until end of table is reached
        Do
            lstRegisteredFees.AddItem rstRegisteredFees("Fee Name")
            rstRegisteredFees.MoveNext
        Loop Until rstRegisteredFees.EOF
    End If
            
End Sub
Private Sub Form_Load()
    Loading = True
End Sub
